using Edu.Common.Enum;
using Edu.Model.Entity.Web;
using Edu.Model.ViewModel.Web;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VT.FW.DB.Dapper;

namespace Edu.Repository.Web
{
    /// <summary>
    /// 品牌漫画管理仓储层
    /// </summary>
    public class RB_Web_CartoonRepository : BaseRepository<RB_Web_Cartoon>
    {
        /// <summary>
        /// 获取品牌卡通分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowsCount"></param>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Web_Cartoon_ViewModel> GetWebCartoonPageRepository(int pageIndex, int pageSize, out long rowsCount, RB_Web_Cartoon_ViewModel query)
        {
            rowsCount = 0;
            var parameters = new DynamicParameters();
            StringBuilder builder = new StringBuilder();
            builder.Append(@"
SELECT A.* 
FROM RB_Web_Cartoon AS A
WHERE 1=1
");
            builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Cartoon_ViewModel.Status), (int)DateStateEnum.Normal);
            if (query == null)
            {
                return new List<RB_Web_Cartoon_ViewModel>();
            }
            else
            {
                if (query.Group_Id > 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Cartoon_ViewModel.Group_Id), query.Group_Id);
                }
                if (!string.IsNullOrEmpty(query.Name))
                {
                    builder.AppendFormat(" AND A.{0} LIKE @Name ", nameof(RB_Web_Cartoon_ViewModel.Name));
                    parameters.Add("Name", "%" + query.Name.Trim() + "%");
                }
            }

            builder.AppendFormat(" ORDER BY A.{0} DESC ", nameof(RB_Web_Cartoon_ViewModel.Id));
            return GetPage<RB_Web_Cartoon_ViewModel>(pageIndex, pageSize, out rowsCount, builder.ToString(), parameters).ToList();
        }
    }
}